/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package metier;

import javax.swing.Icon;
import javax.swing.JOptionPane;

/**
 *
 * @author emile.lalorcey
 */
public class FeeSombre extends Personnage{
    private String type;
    
    /**
     * Constructeur de la classe FeeSombre
     * @param nom
     * @param img
     * @param energie
     * @param dureeVie
     * @param ty 
     */
    public FeeSombre(String nom, String img, int energie, int dureeVie, String ty){
        super(nom, img, energie, dureeVie);
        this.type = ty;
    }
    
    public String getType(){
        return this.type;
    }
    
    
    /**
     * Methode saluer
     * @param unPerso
     * @return 
     */
    @Override
    public String saluer(Personnage unPerso){
        String titre = this.getNom() + " salue " + unPerso.getNom();
        String message = "Bonjour " + unPerso.getNom() + " Comment allez-vous ajourd'hui";
        //JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE);
        Icon imgPerso = new javax.swing.ImageIcon(getClass().getResource("/img/" + this.getImg()));
        JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE, imgPerso);
        return message;
    }
    
    /**
     * Methode rencontrer faisant appelle  un mini jeu nomm jeu baton
     * @param unPerso
     * @return 
     */
    @Override
    public String rencontrer(Personnage unPerso){
        String titre = this.getNom() + " rencontre " + unPerso.getNom();
        String message = "Bonjour " + unPerso.getNom() + " !";
        JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE);
        //Icon imgPerso = new javax.swing.ImageIcon(getClass().getResource("/img/" + this.getImg()));
        //JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE, imgPerso);
        JeuBaton baton = new JeuBaton();
        boolean gagner = baton.deroulerJeu();
        if(gagner){
            unPerso.varierDureeVie(2);
            this.varierEnergie(-1);
        }
        else{
            unPerso.varierEnergie(-2);
        }
        return message;
    }
    /**
     * Methode to string addapter  une fe sombre
     * @return les caractristique d'une Fe Sombre
     */
    @Override
    public String toString(){
        return super.toString()+this.type;
    }
    
    /** 	
     * Dtermine si l'objet spcifi est gal  l'objet actuel.
     * @param obj
     * @return boolean signifiant si oui ou non les objets sont gaux
     */
    @Override
    public boolean equals(Object obj){
        
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        return super.equals(obj);
    }
}
